public class Countprimes2 {
    
    private static int steps;

    public static void main(String[] args) {
        if (args.length != 1) {
            System.out.println("Usage: java Countprimes2 <limit>");
            return;
        }
        long limit = Long.parseLong(args[0]);
        int numPrimes = 0;
        long biggest = 0;
        System.out.println("Counting primes using primeTest2...");
        for (long n = 2; n <= limit; n++) {
            steps = 0;
            if (primeTest2(n) == true) {
                System.out.printf("%d is prime - took %d steps\n", n, steps);
                numPrimes++;
                biggest = n;
            }
        }
        System.out.printf("Found %d primes less than or equal to %d\n", numPrimes, limit);
        System.out.printf("Biggest prime is %d\n", biggest);
    }
    
    //-------------------------------------------------------------------

    public static boolean primeTest2(long n) {
        if (n < 2) return false;
        for (long i = 2; i <= n/2; i++) {
            steps++;
            if (n % i == 0) return false;
        }
        return true;
    }
}
