import java.util.ArrayList; // new

public class Countprimes5 {
    
    private static ArrayList<Long> primeList = new ArrayList<Long>(); // new
    private static int steps;

    public static void main(String[] args) {
        if (args.length != 1) {
            System.out.println("Usage: java Countprimes5 <limit>");
            return;
        }
        long limit = Long.parseLong(args[0]);
        int numPrimes = 0;
        long biggest = 0;
        primeList.clear(); // new
        System.out.println("Counting primes using primeTest5...");
        for (long n = 2; n <= limit; n++) {
            steps = 0;
            if (primeTest5(n) == true) {
                System.out.printf("%d is prime - took %d steps\n", n, steps);
                numPrimes++;
                biggest = n;
                primeList.add(n); // new
            }
        }
        System.out.printf("Found %d primes less than or equal to %d\n", numPrimes, limit);
        System.out.printf("Biggest prime is %d\n", biggest);
    }
    
    //-------------------------------------------------------------------

    public static boolean primeTest5(long n) {
        if (n < 2) return false;
        if (n == 2) return true;
        if (n % 2 == 0) return false;
        long squareRoot = (long) Math.sqrt(n);
        for (Long i : primeList) {
            steps++;
            if (i > squareRoot) return true;  // only check up to sqrt(n)
            if (n % i == 0) return false;
        }
        return true;
    }
}
