public class Fastpower {
   
    public static void main(String[] args) {
        if (args.length != 2) {
            System.out.println("Usage: java Fastpower <base> <exponent>");
            return;
        }
        double x = Double.parseDouble(args[0]);
        long n = Long.parseLong(args[1]);
        System.out.printf("%s ^ %s = %s\n", x, n, power(x, n));
    }
    
    public static double power(double b, long n) {
        if (n == 0) {
            return 1;
        } else {
            return times(b, power(b, n-1));
        }
    }

    public static boolean isEven(long n) {
        return (n % 2 == 0);
    }
    
    public static double square(double x) {
        return x * x;
    }

    public static double times(double x, double y) {
        return x * y;
    }
}
